# a cube with a crack in ascii , handcoded by Steve Vavasis
# comment lines are marked with a # sign.  Comment continues
# to the end of the line.  Otherwise line breaks are not significant
# (they count the same as spaces), and parentheses are used for grouping.
# First three items in the file: the file type, brep_v2.0, the
# intrinsic dimension of the object, 3, and the dimension in which
# it is embedded, also 3:

brep_v2.0 3 3 


# next comes the brep's property value pairs.  This is a list of
# pairs of strings -- a property and value.  Strings are terminated
# by whitespace (space, tab, newline) EXCEPT a string is not terminated
# by whitespace if there is a pending open parenthesis.
# This brep has one property, "global_id", and its value is
# (steve 1 19980622).

(geo_global_id (steve 1 19980622)) 


# Here comes the list of control points, enclosed in
# Each c.p. has a number of coordinates equal to the embedded
# dimension of the brep.
# This brep has six control points.

(
0 0 0 # cp 0.  This is a comment.
0 0 1 # cp 1
0 1 0 # cp 2
0 1 1 # cp 3
1 0 0 # cp 4
1 0 1 # cp 5
1 1 0 # cp 6 
1 1 1 # cp 7
0 .66666666666666667 .5 # cp 8
.5 .66666666666666667 .25 # cp 9
.75 .58333333333333333 .375 # cp 10
1 .5 .5 # cp 11
.75 .41666666666666667 .625 #cp 12
.5 .33333333333333333 .75 #cp 13
0 .33333333333333333 .5 #cp 14
0    .58333333333333333 .5 #cp 15
.375 .54166666666666667 .4375 #cp 16
.375 .45833333333333333  .5625 #cp 17
0 .41666666666666667 .5 #cp 18
0 .5 .5 #cp 19
)

# Here comes the list of topological vertices.  They have the
# unimaginative names v0,...,v7.  Each topological entity is
# described by a 5-item list.  The five items are:
#    name
#    list of property-value pairs
#    list of bounding faces
#    list of lower dim. internal boundaries
#    list of geometric entities
# The geometric entity for a topological vertex is a single
# control point, which coded as "vertex <cp-num>".

(
v0 () () () ((vertex 0))
v1 () () () ((vertex 1))
v2 () () () ((vertex 2))
v3 () () () ((vertex 3))
v4 () () () ((vertex 4))
v5 () () () ((vertex 5))
v6 () () () ((vertex 6))
v7 () () () ((vertex 7))
crack_ep1 () () () ((vertex 14))
crack_ep2 () () () ((vertex 8))
)


# Here comes the list of top. edges.  Each edge has the same 
# five items mentioned above.  The geometric entities for
# a top. edge. are one or more bezier curves of the form
#  bezier_curve <degree> <cp_0> ... <cp_degree>
# where cp_0,...,cp_degree are the control points for the curve.

(
e00 () (v0 v1) () ((bezier_curve 1 0 1))
e01 () (v2 v3) () ((bezier_curve 1 2 3))
e02 () (v4 v5) () ((bezier_curve 1 4 5))
e03 () (v6 v7) () ((bezier_curve 1 6 7))
e10 () (v0 v2) () ((bezier_curve 1 0 2))
e11 () (v1 v3) () ((bezier_curve 1 1 3))
e12 () (v4 v6) () ((bezier_curve 1 4 6))
e13 () (v5 v7) () ((bezier_curve 1 5 7))
e20 () (v0 v4) () ((bezier_curve 1 0 4))
e21 () (v1 v5) () ((bezier_curve 1 1 5))
e22 () (v2 v6) () ((bezier_curve 1 2 6))
e23 () (v3 v7) () ((bezier_curve 1 3 7))

crack_outer () (crack_ep1 crack_ep2) () ((bezier_curve 1 14 19)
   (bezier_curve 1 19 8))
crack_inner () (crack_ep1 crack_ep2) () ((bezier_curve 2 8 9 10)
  (bezier_curve 2 10 11 12) 
  (bezier_curve 2 14 13 12))

)

# Here come the list of top. surfaces.  The geometric entities
# for a surface are either
#   bezier_triangle <degree> <cp_0> ... <cp_m>
#  where m = (degree + 1) * (degree + 2) / 2
# or
#  bezier_quad <degree1> <degree2> <cp_0> ... <cp_m>
#  where m = (degree1 + 1) * (degree2 + 1).

(
s00 () (e10 e12 e20 e22) () ((bezier_quad 1 1 0 2 4 6))
s01 (color (1 1 1 0)) (e11 e13 e21 e23) () ((bezier_quad 1 1 1 3 5 7))
s10 () (e00 e02 e20 e21) () ((bezier_quad 1 1 0 1 4 5))
s11 () (e01 e03 e22 e23) () ((bezier_quad 1 1 2 3 6 7))
s20 () (e00 e01 e10 e11 crack_outer crack_outer) () (
  (bezier_triangle 1 1 14 19)
  (bezier_triangle 1 1 19 3)
  (bezier_triangle 1 3 19 8)
  (bezier_triangle 1 0 19 14)
  (bezier_triangle 1 0 19 2)
  (bezier_triangle 1 2 19 8)
  (bezier_triangle 1 0 1 14)
  (bezier_triangle 1 2 8 3))
cracksurf (color (1 0 0 1)) (crack_outer crack_inner) () ((bezier_triangle 2 19 15 16 8 9 10)
  (bezier_triangle 2 19 16 17 10 11 12)
  (bezier_triangle 2 19 17 18 12 13 14))


s21 () (e02 e03 e12 e13) () ((bezier_quad 1 1 4 5 6 7))
)

# Finally, here is the list of topological regions.  Regions do not
# have geometric entities associated with them.

(
r () (s00 s01 s10 s11 s20 s21 cracksurf cracksurf) () ()
)
