%% startup file for QMG 2.0


%% figure out where the QMG root is.

global QMG_ROOT
QMG_ROOT = getenv('QMG_ROOT');

if length(QMG_ROOT) == 0
  % Get here if there is no environment variable
  % called QMG_ROOT set.  In this case, try
  % .. as the QMG root.

  if exist(fullfile('..', 'mex', '')) == 7 & ...
     exist(fullfile('..', 'mfiles', '')) == 7 & ... 
     exist(fullfile('..', 'mfiles2', '')) == 7
    QMG_ROOT = fullfile(pwd, '..', '');
  else
    error('Unable to set QMG_ROOT; see documentation concerning QMG set up in the readme file')
  end
end



path(path, fullfile(QMG_ROOT, 'mex', ''))
path(path, fullfile(QMG_ROOT, 'mfiles', ''))
path(path, fullfile(QMG_ROOT, 'mfiles2', ''))
global GM_DEFAULT_TOL
GM_DEFAULT_TOL = 1e-14;
global GM_BREP_TYPE_CODE
GM_BREP_TYPE_CODE = 'brep_v2.0';
global GM_SIMPCOMP_TYPE_CODE
GM_SIMPCOMP_TYPE_CODE = 'mesh_v2.01';
global GM_GEO_ID_PROP;
GM_GEO_ID_PROP = 'geo_global_id';
global GMVIZGUI_HANDLE;
GMVIZGUI_HANDLE = gmvizgui1;
gmvizgui_callback(14);
gmvizgui_callback(0);
global QMG_DATA
QMG_DATA = fullfile(QMG_ROOT, 'data', '');


disp('QMG 2.0.2 startup file successfully completed.')
disp('Type alltests to test QMG.  This takes a long time.')
disp('Type helpqmg to start web-based documentation.')


if strcmp(lower(computer),'sol2') & strcmp(lower(gm_whichcompiler),'gcc')
  disp('    *** Cautionary note ***')
  disp('You are using QMG 2.0 compiled with a gnu compiler')
  disp('under Solaris.  A known bug arises from this configuration')
  disp('that may cause the ''exit'' command to fail. The only way to exit')
  disp('this Matlab session may be to kill this process.')
end
