function sizeval = gm_sizecontrol_interior(realpoint, fspec, sizefunc)
%% gm_sizecontrol_interior: called by gm_meshgen to control interior element size
%% sz = gm_sizecontrol_interior(realpoint, fspec, sizefunc)
%% This routine is invoked by the mesh generators to
%% determine the mesh size function.  Argument proc is the
%% size control function.  See the documentation for more
%% information.


proc = gm_strim(sizefunc);
if proc(1) ~= '('
  error('size control procedure must start with a parenthesis')
end
if proc(length(proc)) ~= ')'
  error('Unbalanced parentheses in size control procedure');
end

proc(1) = ' ';
proc(length(proc)) = ' ';
proc = gm_strim(proc);
[first, rest] = strtok(proc);
first = gm_strim(first);
rest = gm_strim(rest);

%% The next test could be commented out because "const" is
%% caught by the mesh generators, so gmsize_control should
%% never be reached in that case.

if strcmpi(first, 'const')
  sizeval = str2num(rest);
elseif strcmpi(first, 'formula') | strcmpi(first, 'vecformula')
  formula = gm_percentsub(rest, 'realpoint(', '+1)');
  sizeval = eval(formula);
else
  error('Unknown sizecontrol keyword');
end
