function [varargout]=gmapply(varargin)
%% gmapply applies an affine transformation to a mesh or brep
%%   Matlab: obj2 = gmapply(mat, obj1);
%%   Tcl/Tk: gmset obj2 [gmapply $mat $obj1] 
%% Here, obj1 is a brep or simplicial complex, and mat is an affine
%% transformation of the correct dimension.  The affine transformation is
%% applied to the object, and the transformed object is returned.  This
%% function, when applied to breps, assigns the same property-value lists
%% to faces of the output brep that were assigned to the input brep.  The
%% mat argument is a matrix of size d-by-(d+1), where d is the embedded
%% dimension of the object.  If we partition the matrix as [A,b] where A
%% is d-by-d and b is d-by-1, then the transformation applied is x -->
%% A*x - b.
gm_errmsg('gmapply')
