function b = gmmake_circ(numsubdiv)
% gmmake_circ: Make a cubic bezier spline approximation to a circle.
%  b = gmmake_circ(numsubdiv)
% returns a brep b that is a cubic bezier spline with numsubdiv
% breakpoints to the unit circle.

if numsubdiv < 3
  error('Number of subdivisions must be at least 3')
end
[vertex,code] = gm_circ_approx(0,2*pi,numsubdiv);
vertex = vertex(1:3*numsubdiv,:);
code = code(1:3*numsubdiv,:);
code(1) = 0;
b = gm_cpoly(vertex,code);

% ------------------------------------------------------------------
% Copyright (c) 1999 by Cornell University.  All rights reserved
% See the accompanying file 'Copyright' for authorship information,
% the terms of the license governing this software, and disclaimers
% concerning this software.
% ------------------------------------------------------------------
% This file is part of the QMG software.  
% Version 2.0 of QMG, release date September 3, 1999
% ------------------------------------------------------------------
