function handle = gmviz_init_vrmlplot(bbox, filename, filestat)

maxwidth = max(bbox(:,2) - bbox(:,1));
if maxwidth <= 0
  multiplier = 1e-4;
else
  multiplier = maxwidth * 1e-4;
end
camerax = 0.5 * (bbox(1,1) + bbox(1,2));
cameray = 0.5 * (bbox(2,1) + bbox(2,2));
cameraz = bbox(3,2) + 3 * maxwidth;
if strcmpi(filestat,'replace');
  channel = fopen(filename, 'w');
else
  channel = fopen(filename, 'a');
end

fprintf(channel, '#VRML V1.0 ascii\n');
fprintf(channel, 'Separator {\n');
fprintf(channel, '  PerspectiveCamera { position %f %f %f }\n', ...
           camerax, cameray, cameraz);

handle = [channel, multiplier];

