% QMG test 11: miscellaneous tests.

% test gm_addpropval & size control property

% make a square
gradedsquare = gm_cpoly([0 0; 0 1; 1 1; 1 0], [0 1 1 1]');
gradedsquare{6}{1,0} = {'sizecontrol'; '(formula 1.005-%1)'};

pr1  = gm_lookup_prop(gradedsquare, 1, 0, 'sizecontrol');

show = 0;
global interactive
if length(interactive) > 0
  show = 1;
end

if show
 disp(sprintf('prop = %s', pr1))
end


mesh = gmmeshgen(gradedsquare, 'show',  show);

if show
    gmviz(mesh)
end

asp  = gmchecktri(gradedsquare,mesh);

[scrap, numvtx] = size(mesh{4});

global aspprod
global meshsizesum

if length(aspprod) > 0
    aspprod  = aspprod * asp;
    meshsizesum = meshsizesum + numvtx;
end


% test gmboundary

m2 = gmboundary(mesh);
[scrap, numvtx] = size(m2{4});

if length(aspprod) > 0
    meshsizesum = meshsizesum + numvtx;
end

% test gmq11read

global QMG_DATA
tubeobj = gmq11read(fullfile(QMG_DATA, 'tubeobj.brp'));

m  = gmmeshgen(tubeobj, 'show', show);
[scrap, numvtx] = size(m{4});
asp = gmchecktri(tubeobj,m);

if length(aspprod) > 0
    aspprod  = aspprod * asp;
    meshsizesum = meshsizesum + numvtx;
end




% ------------------------------------------------------------------
% Copyright (c) 1999 by Cornell University.  All rights reserved
% See the accompanying file 'Copyright' for authorship information,
% the terms of the license governing this software, and disclaimers
% concerning this software.
% ------------------------------------------------------------------
% This file is part of the QMG software.  
% Version 2.0 of QMG, release date September 3, 1999.
% ------------------------------------------------------------------


