% QMG test 2.  This test generates a torus made up of 36
% biquadratic patches and generates a mesh for
% it.  The mesh size is restricted to 0.5

t = gmmake_torus(1,2,6);
show = 0;
global interactive
if length(interactive) > 0
  show = 1;
end

mesh =  gmmeshgen(t, 'size', '(const .5)', 'curve', '(const 1)', 'show', show);

[scrap, numvtx] = size(mesh{4});
asp = gmchecktri(t, mesh, 1, 1e-10);

global aspprod
global meshsizesum

if length(aspprod) > 0
    aspprod  = aspprod * asp;
    meshsizesum = meshsizesum + numvtx;
end



% ------------------------------------------------------------------
% Copyright (c) 1999 by Cornell University.  All rights reserved
% See the accompanying file 'Copyright' for authorship information,
% the terms of the license governing this software, and disclaimers
% concerning this software.
% ------------------------------------------------------------------
% This file is part of the QMG software.  
% Version 2.0 of QMG, release date September 3, 1999.
% ------------------------------------------------------------------

