%% Test 4: mesh a cylinder with two small spheres removed (like bubbles)

cyl1 = gmmake_cyl(4);
global QMG_DATA
s = gm_read(fullfile(QMG_DATA, 'sphere3.geo'));
bubble1 = gmapply([0.01, 0, 0, -0.02; 0, 0.01, 0, 0; 0, 0, 0.01, 0], s);
bubble2 = gmapply([0.01, 0, 0, 0.02; 0, 0.01, 0, 0; 0, 0, 0.01, 0], s);
cyl2 = gmcavity(cyl1, bubble1);
cyl3 = gmcavity(cyl2, bubble2);
show = 0;
global interactive
if length(interactive) > 0
  show = 1;
end

mesh = gmmeshgen(cyl3, 'curve', '(const 1.2)', 'show', show);
asp = gmchecktri(cyl3, mesh);

global aspprod
global meshsizesum

[scrap, numvtx] = size(mesh{4});

if length(aspprod) > 0
    aspprod  = aspprod * asp;
    meshsizesum = meshsizesum + numvtx;
end



% ------------------------------------------------------------------
% Copyright (c) 1999 by Cornell University.  All rights reserved
% See the accompanying file 'Copyright' for authorship information,
% the terms of the license governing this software, and disclaimers
% concerning this software.
% ------------------------------------------------------------------
% This file is part of the QMG software.  
% Version 2.0 of QMG, release date September 3, 1999.
% ------------------------------------------------------------------

