% QMG test 8: a cube in standard orientation versus
% a tilted cube.

global QMG_DATA
cube  = gmoffread(fullfile(QMG_DATA, 'cube.off'));

show = 0;
global interactive
if length(interactive) > 0
  show = 1;
end

mesh = gmmeshgen(cube, 'show', show);

asp = gmchecktri(cube,mesh)
[scrap,numvtx] = size(mesh{4});
global aspprod
global meshsizesum

if length(aspprod) > 0
  aspprod = aspprod * asp;
  meshsizesum = meshsizesum + numvtx;
end

q = [ -0.84910409704140  -0.40704628877252   0.33665345859509 0
   0.23026379507690  -0.85881459325243  -0.45762001605420 0
   0.47539543231325  -0.31104792751790   0.82295101295431 0];

tiltcube = gmapply(q,cube);

mesh2 = gmmeshgen(tiltcube, 'show', show);

% Display the properties of the second mesh

asp2  = gmchecktri(tiltcube, mesh2);
[scrap,numvtx2]  = size(mesh2{4});


if length(aspprod) > 0
  aspprod = aspprod * asp2;
  meshsizesum = meshsizesum + numvtx2;
end


% ------------------------------------------------------------------
% Copyright (c) 1999 by Cornell University.  All rights reserved
% See the accompanying file 'Copyright' for authorship information,
% the terms of the license governing this software, and disclaimers
% concerning this software.
% ------------------------------------------------------------------
% This file is part of the QMG software.  
% Version 2.0 of QMG, release date September 3, 1999.
% ------------------------------------------------------------------
