% QMG: test of visualization.

disp('This file tests graphics capabilities of QMG 2.0 under Matlab.')
disp('First, here is a test of 2D graphics.')
g = gm_read(fullfile(QMG_DATA, 'logo2.geo'));
gmviz(g, 'b', 1)
disp('A plot the letter Q outlined in blue should have appeared')
disp('n a new graphics window.  It will appear very distorted')
disp('if the Bezier subdivision option is a small number.')
testviz_pause
gmvizgui
disp('The visualization control panel should appear on your screen');
disp('In the visualization control panel, increase the number of')
disp('Bezier subdivisions using the slider.')
testviz_pause
gmviz(g,'r', 1)
disp('A plot the letter Q outlined in red should have appeared')
disp('in a new graphics window.  With the increased number')
disp('of Bezier subdivisions, it should appear more like a curved object.')
testviz_pause
disp('For the test of 3D graphics, you can either view an object')
disp('in Matlab or in your web browser.  To view it in Matlab')
disp('click the Internal radiobutton under 3D graphics engine.')
disp('To view it in the web browser, click the External radiobutton')
disp('and make sure ''Notify web browswer on each update'' is selected')
disp('in the panel.  For viewing 3D graphics in your browser, you')
disp('must have a VRML viewer installed.  For more information about')
disp('VRML viewers, see http://www.web3d.org.')
testviz_pause
b  = gmrndcolor(gmoffread(fullfile(QMG_DATA,'dodec.off')));
gmviz(b)
disp('A dodecahedron with each facet a different color should have')
disp('appeared either as a Matlab graphic or in your browser.')
disp('This is the end of the test.')


