// ------------------------------------------------------------------
// qmgnamesp.h
//
// This file contains the classes in namespace QMG:MG, that is,
// classes used specifically for mesh generation.
// ------------------------------------------------------------------
// Author: Stephen A. Vavasis
// Copyright (c) 1999 by Cornell University.  All rights reserved.
// 
// See the accompanying file 'Copyright' for authorship information,
// the terms of the license governing this software, and disclaimers
// concerning this software.
// ------------------------------------------------------------------
// This file is part of the QMG software.  
// Version 2.0 of QMG, release date September 3, 1999.
// ------------------------------------------------------------------

#ifndef QMG_MG_NAMESP
#define QMG_MG_NAMESP


#include "qnamesp.h"

namespace QMG {
  namespace MG {

    using namespace QMG;

    class Mask;
    class Base3;
    class BoxFaceDag;
    class Patch_in_ActiveBox;
    class BoxAddress;
    class ActiveBox;
    class NonConstActiveBox;
    class ActiveBox_As_Parent;
    class ActiveBoxVec;
    class Brep_Orbits;
    class IncidenceTable;
    class PatchTable;
    class Gui;
    class SizeControl;
    class Logstream;
    class My_bool;
    class IntCoord;
    class SizeControl;
    class Error;
    class Frontend_Data;
    class Meshgen_gui;
    class Separation_Functor;
    struct PatchInBrepAddress;

    typedef float Weight_t;
    typedef vector<int> CompoLabel;
    
    template<class T>
      class PatchTableIndexMap;




    const int MINDIM = 2;
    const int MAXDIM_EXP = 8;
    const int MAXDIM_3EXP = 27;
    const int MAXLEV = 30;
    const int NUM_CURVATURE_TEST_DIRECTION = 13;
  }
}

#endif
