proc gmmake_circ numsubdiv {
    # gmmake_circ $numsubdiv
    # Make a cubic bezier approximation to a circle.  Argument
    # is the number of subdivisions.

    if {$numsubdiv < 3} {
	error "Number of bezier subdivisions must be at least 3"
    }
    global PI
    global qmg_library2
    gmset {vertex code} [gm_circ_approx 0 [expr 2 * $PI] $numsubdiv]
    set vertex [lrange $vertex 0 [expr 3 * $numsubdiv - 1]]
    set code [lrange $code 0 [expr 3 * $numsubdiv - 1]]
    set code [lreplace $code 0 0 0]
    set c [gm_cpoly $vertex $code]
    return $c
}


# ------------------------------------------------------------------
# Copyright (c) 1999 by Cornell University.  All rights reserved
# See the accompanying file 'Copyright' for authorship information,
# the terms of the license governing this software, and disclaimers
# concerning this software.
# ------------------------------------------------------------------
# This file is part of the QMG software.  
# Version 2.0 of QMG, release date September 3, 1999
# ------------------------------------------------------------------
